
#include "sd.h"
#include "spi.h"


//ģʽ  //spi low speed
void SPI_Low(void)
{
	Hardware_Spi_Init(3);
}

//ģʽ	//spi full speed
void SPI_High(void)
{
	Hardware_Spi_Init(0);
}

//˿ڳʼģʽʼ  //port initialize
void SPI_Init(void)
{
	SPI_Low();
}

//дһֽ			//read and write one byte
uint8 SPI_WriteByte(uint8 val)
{
	SPDAT  = val;
	while((SPSTAT&0x80)==0);
	SPSTAT = 0xC0;  //SPIFд10 
	return SPDAT;
}

void MMC_SD_Init(void)
{
	SPI_Init();
	SPI_CS_Deassert();
}

//sdд
uint8 MMC_SD_SendCommand(uint8 cmd, uint32 arg)
{
	uint8 r1;
	uint8 retry=0;

	SPI_WriteByte(0xff);
	SPI_CS_Assert();

	SPI_WriteByte(cmd | 0x40);//ֱд
	SPI_WriteByte(arg>>24);
	SPI_WriteByte(arg>>16);
	SPI_WriteByte(arg>>8);
	SPI_WriteByte(arg);
	SPI_WriteByte(0x95);

	while((r1 = SPI_WriteByte(0xff)) == 0xff)//ȴӦ
		if(retry++ > 8) break;//ʱ˳

	SPI_CS_Deassert();

	return r1;//״ֵ̬
}

//sdλ
uint8 MMC_SD_Reset(void)
{
	uint8 i;
	uint8 retry;
	uint8 r1=0;
	retry = 0;
	SPI_Low();

	do
	{
		for(i=0;i<10;i++) SPI_WriteByte(0xff);
		r1 = MMC_SD_SendCommand(0, 0);//idle
		retry++;
		if(retry>10) return 1;//ʱ˳
	} while(r1 != 0x01);

	retry = 0;
	do
	{
		r1 = MMC_SD_SendCommand(1, 0);//active
		retry++;
		//if(retry>100) return 1;//ʱ˳
	} while(r1);
	SPI_High();
	r1 = MMC_SD_SendCommand(59, 0);//crc

	r1 = MMC_SD_SendCommand(16, 512);//С512

	return 0;//
}

//һ
uint8 MMC_SD_ReadSingleBlock(uint32 sector, uint8* buffer)
{
	uint8 r1;
	uint16 i;
	//uint8 retry=0;

	r1 = MMC_SD_SendCommand(17, sector<<9);//

	if(r1 != 0x00)
		return r1;

	SPI_CS_Assert();
	//ݵĿʼ
	while(SPI_WriteByte(0xff) != 0xfe);//if(retry++ > 50){SPI_CS_Deassert();return 1;}

    for(i=0;i<64;i++)	 //д뵽ݻ
    {
        *(buffer++)=SPI_WriteByte(0xff);
        *(buffer++)=SPI_WriteByte(0xff);
        *(buffer++)=SPI_WriteByte(0xff);
        *(buffer++)=SPI_WriteByte(0xff);
        *(buffer++)=SPI_WriteByte(0xff);
        *(buffer++)=SPI_WriteByte(0xff);
        *(buffer++)=SPI_WriteByte(0xff);
        *(buffer++)=SPI_WriteByte(0xff);
    }
	SPI_WriteByte(0xff);//αcrc
	SPI_WriteByte(0xff);

	SPI_CS_Deassert();

	return 0;
}


//дһ
uint8 MMC_SD_WriteSingleBlock(uint32 sector,const uint8* buffer)
{
	uint8 r1;
	uint16 i;
	//uint8 retry=0;

	r1 = MMC_SD_SendCommand(24, sector<<9);//д
	if(r1 != 0x00)
		return r1;

	SPI_CS_Assert();

	SPI_WriteByte(0xff);
	SPI_WriteByte(0xff);
	SPI_WriteByte(0xff);

	SPI_WriteByte(0xfe);//ʼ

	for(i=0; i<64; i++)//512ֽ
	{
		SPI_WriteByte(*buffer++);
		SPI_WriteByte(*buffer++);
		SPI_WriteByte(*buffer++);
		SPI_WriteByte(*buffer++);
		SPI_WriteByte(*buffer++);
		SPI_WriteByte(*buffer++);
		SPI_WriteByte(*buffer++);
		SPI_WriteByte(*buffer++);
	}

	SPI_WriteByte(0xff);
	SPI_WriteByte(0xff);

	r1 = SPI_WriteByte(0xff);

	if( (r1&0x1f) != 0x05)//ȴǷɹ
	{
		SPI_CS_Deassert();
		return r1;
	}
	//ȴ
	while(!SPI_WriteByte(0xff));//if(retry++ > 50){SPI_CS_Deassert();return 1;}

	SPI_CS_Deassert();

	return 0;
}
